//************************************************************************
// KS108.H
// LowLevel Routinen fr LCD-Displays mit KS0108
//
// Hier fr Displaytech 64240A
//
// hk@holger-klabunde.de
// http://www.holger-klabunde.de
// 11.10.2003
// Compiler WinAVR
//************************************************************************

#ifndef KS108_H
#define KS108_H

//#####################################################
//# Number of NOP's below is based on 11.059MHz Clock #
//#####################################################

#define LCD_WIDTH	240  //Display Breite
#define LCD_HEIGHT	64   //Display Hhe

#define INIT_CONTROL_PINS() { DDRD=0xFF; DDRF=0xFF; RSTB_ON(); } //control pins to output

#define DATA_PORT	PORTD
#define DATA_DIR_IN()  	{ DDRD=0x00; DATA_PORT=0xFF; } // set io-pins to inputs with pullups
#define DATA_DIR_OUT()	DDRD=0xFF; // set io-pins to outputs
#define READ_DATA()   	PIND	  // read PIN, ! NOT ! PORT
#define WRITE_DATA(a)  	DATA_PORT=(a); // write to data port

// Zu meiner Erinnerung:
// Im Assemblerlisting wurde PORTF gelesen, modifiziert, und zurckgeschrieben.
// Wieso kein krzeres "sbi PORTF,BIT" ??? Datenblatt lesen !
// sbi/cbi funktionieren nur mit SFR's von 0x00 bis 0x1F. PORTF liegt darber.
// Es bringt jetzt aber hier auch nichts PORTF und PORTD zu tauschen (habs versucht).
// Das was man dann gewinnt mu man in Wait_for_E() wieder draufgeben weil das Timing
// fr "E_ON/E_OFF" nicht mehr stimmt.
//
// Fr andere Projekte sollte man aber in Erinnerung behalten das PORTF nicht fr
// extrem schnelle Anwendungen geeignet ist ;)

#define RS_PIN		7
#define RS_PORT		PORTF
#define RS_ON()	       	{ sbi(RS_PORT,RS_PIN); }
#define RS_OFF()       	{ cbi(RS_PORT,RS_PIN); }

#define RW_PIN		6
#define RW_PORT		PORTF
#define RW_ON()	       	{ sbi(RW_PORT,RW_PIN); NOP(); NOP(); }
#define RW_OFF()       	{ cbi(RW_PORT,RW_PIN); NOP(); NOP(); } //min 140ns

#define E_PIN		5
#define E_PORT		PORTF
#define E_ON()	       	{ sbi(E_PORT,E_PIN); Wait_for_E(); } //min 450ns
#define E_OFF()       	{ cbi(E_PORT,E_PIN); Wait_for_E(); } //min 450ns

#define RSTB_PIN	4
#define RSTB_PORT	PORTF
#define RSTB_ON()      	sbi(RSTB_PORT,RSTB_PIN);
#define RSTB_OFF()     	cbi(RSTB_PORT,RSTB_PIN);

#define CS1_PIN		0
#define CS1_PORT	PORTF
#define CS1_ON()      	sbi(CS1_PORT,CS1_PIN);
#define CS1_OFF()     	cbi(CS1_PORT,CS1_PIN);

#define CS2_PIN		1
#define CS2_PORT	PORTF
#define CS2_ON()      	sbi(CS2_PORT,CS2_PIN);
#define CS2_OFF()     	cbi(CS2_PORT,CS2_PIN);

#define CS3_PIN		2
#define CS3_PORT	PORTF
#define CS3_ON()      	sbi(CS3_PORT,CS3_PIN);
#define CS3_OFF()     	cbi(CS3_PORT,CS3_PIN);

#define CS4_PIN		3
#define CS4_PORT	PORTF
#define CS4_ON()      	sbi(CS4_PORT,CS4_PIN);
#define CS4_OFF()     	cbi(CS4_PORT,CS4_PIN);

extern unsigned char ReadDisplay(void);
extern void WriteDisplay(unsigned char dat);
extern unsigned char SetPixel(unsigned char xpos, unsigned char ypos, unsigned char mode);
extern unsigned char GetPixel(unsigned char xpos, unsigned char ypos);
extern unsigned char GetChipNumber(unsigned char xpos);
extern void SetChipNumber(unsigned char num);
extern unsigned char GetPageNumber(unsigned char ypos);
extern unsigned char SetPageNumber(unsigned char num);
extern unsigned char SetRow(unsigned char xpos);
extern unsigned char SetPosition(unsigned char xpos, unsigned char ypos);
extern void DisplayOn(void);
extern void ClearScreen(void);
extern unsigned char CheckBusy(void);

#endif
